- Qt 5.15
- Qt 3D
- C++ Classes
- QNormalDiffuseMapMaterial
- Qt 5.15.11 Reference Documentation

# QNormalDiffuseMapMaterial Class

class Qt3DExtras::QNormalDiffuseMapMaterial

The QNormalDiffuseMapMaterial provides a default implementation of the phong lighting and bump effect where the diffuse light component is read from a texture map and the normals of the mesh being rendered from a normal texture map. More...

Header: | #include <QNormalDiffuseMapMaterial>
qmake: | QT += 3dextras
Since: | Qt 5.7
Inherits: | Qt3DRender::QMaterial
Inherited By: | Qt3DExtras::QNormalDiffuseMapAlphaMaterial

This class is obsolete. It is provided to keep old source code working. We strongly advise against using it in new code.

This class was introduced in Qt 5.7.

- List of all members, including inherited members

## Properties

- ambient : QColor
- diffuse : Qt3DRender::QAbstractTexture*
- normal : Qt3DRender::QAbstractTexture*

- shininess : float
- specular : QColor
- textureScale : float

## Public Functions

virtual | ~QNormalDiffuseMapMaterial()
QColor | ambient() const
Qt3DRender::QAbstractTexture * | diffuse() const
Qt3DRender::QAbstractTexture * | normal() const
float | shininess() const
QColor | specular() const
float | textureScale() const

## Public Slots

void | setAmbient(const QColor &ambient)
void | setDiffuse(Qt3DRender::QAbstractTexture *diffuse)
void | setNormal(Qt3DRender::QAbstractTexture *normal)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)
void | setTextureScale(float textureScale)

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(Qt3DRender::QAbstractTexture *diffuse)
void | normalChanged(Qt3DRender::QAbstractTexture *normal)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)
void | textureScaleChanged(float textureScale)

## Detailed Description

This class is deprecated; use QDiffuseSpecularMaterial instead.

The specular lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components are controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the current ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : Qt3DRender::QAbstractTexture*

Holds the current diffuse map texture.

By default, the diffuse texture has these properties:

- Linear minification and magnification filters
- Linear mipmap with mipmapping enabled
- Repeat wrap modeM
- Maximum anisotropy of 16.0

Access functions:

Qt3DRender::QAbstractTexture * | diffuse() const
void | setDiffuse(Qt3DRender::QAbstractTexture *diffuse)

Notifier signal:

void | diffuseChanged(Qt3DRender::QAbstractTexture *diffuse)

### normal : Qt3DRender::QAbstractTexture*

Holds the current normal map texture.

By default, the normal texture has the following properties:

- Linear minification and magnification filters
- Repeat wrap mode
- Maximum anisotropy of 16.0

Access functions:

Qt3DRender::QAbstractTexture * | normal() const
void | setNormal(Qt3DRender::QAbstractTexture *normal)

Notifier signal:

void | normalChanged(Qt3DRender::QAbstractTexture *normal)

### shininess : float

Holds the current shininess as a float value.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the current specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

### textureScale : float

Holds the current texture scale. It is applied as a multiplier to texture coordinates at render time. Defaults to 1.0.

When used in conjunction with QTextureWrapMode::Repeat, textureScale provides a simple way to tile a texture across a surface. For example, a texture scale of `4.0` would result in 16 (4x4) tiles.

Access functions:

float | textureScale() const
void | setTextureScale(float textureScale)

Notifier signal:

void | textureScaleChanged(float textureScale)

## Member Function Documentation

### `[virtual]` QNormalDiffuseMapMaterial::~QNormalDiffuseMapMaterial()

Destroys the QNormalDiffuseMapMaterial instance.